<template>
<v-dialog :value="value" @input="$emit('input')" scrollable max-width="500px" persistent>
  <v-card>
  <v-card-text class="pop">
    <st-title text="Datos del tutor"/>
      <v-form
        ref="form"
        v-model="valid"
      >
      <div class="fields">
        <v-text-field
          v-for="(field, index) in fields"
          v-model="field.value"
          :counter="field.counter"
          :rules="field.rules"
          :label="field.label"
          :type="field.type"
          :key="index"
          required
        />
        <v-checkbox
          v-model="showInfo.value"
          :label="showInfo.label"
        />
      </div>
      <div class="content-footer">
        <st-secondary-btn 
          nombre="Cancelar" 
          @click="$emit('input')"
        />
        <st-primary-btn
          nombre = "Actualizar tutor"
          @click="register"
          :disable="!valid"
          :loading="loading"
        />
      </div>
      </v-form>
    </v-card-text>
  </v-card>
</v-dialog>
</template>
<script>
import user from '@/assets/js/user-fields'
export default {
  props:{
    data: Object,
    value: Boolean
  },
  data(){
    return{
      valid: false,
      loading: false,
      fields: {},
      showInfo:{
        value:false,
        label: 'Permitir acceso a información adicional del alumno'
      }
    }
  },
  mounted(){
    this.fields = Object.assign({}, user) //copy object
    let fields = this.data.fields
    for (let prop in fields){
      this.fields[prop].value = fields[prop].value || ''
    }
    this.showInfo.value = this.data.showInfo 
  },
  methods:{
    async register(){
      let field = this.fields
      let ids = this.data.ids
      let data = {
        'tutor':{
          'correo':field.correo.value,
          'codigo':field.codigo.value,
          'nombres': field.nombres.value,
          'apellidoPaterno': field.apellidoPat.value,
          'apellidoMaterno': field.apellidoMat.value,
          'telefono': field.telefono.value,
          'tienePermisoAccesoInfoAdicional':this.showInfo.value
        }
      }
      this.loading = true
      try{
        let response = await this.$api.updateUser(ids.idTutor,data)
        this.$emit('refresh',{ response: response})
      } catch(e) {
        this.$store.commit('setError', e)
      }
      this.loading = false
    }
  }
}
</script>

<style scoped lang="scss"> 
/* scope for encapsulate css */
</style>

